/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


import java.util.Random;

/**
 *
 * @author Julio Cesar Cachay Perez
 */
public class nuevaruta {

    private double x = 0;
    private double y = 0;
    private int width;
    private int height;
    private double velocidad;
    public double velocidadX;
    public double velocidadY;
    private double anchoSprite = 0;
    private double largoSprite = 0;

    public nuevaruta(int width, int height, double velocidad) {
        this.width = width;
        this.height = height;
        this.velocidad = velocidad;
        velocidadX = velocidad;
        velocidadY = velocidad;
    }

    public double Xmedio() {
        //calculamos la posicion x media, a partir del ancho del objeto a poner en ese lugar
        return ((width / 2) - (anchoSprite / 2));
    }

    public double Ymedio() {
        //calculamos la posicion y media, a partir del largo del objeto a poner en ese lugar
        return ((height / 2) - (largoSprite / 2));
    }

    private void RutaX() {
        setX(getX() + velocidadX);
    }

    private void RutaY() {
        setY(getY() + velocidadY);
    }

    private boolean chocaX() {
        if (getX() <= 0 | getX() + anchoSprite >= width) {
            return true;
        } else {
            return false;
        }
    }

    private boolean chocaY() {
        if (getY() + largoSprite >= height | getY() <= 0) {
            return true;
        } else {
            return false;
        }
    }

    public void almedio() {
        x = Xmedio();
        y = Ymedio();
    }

    public void nuevaruta() {
        if (chocaX() & chocaY()) {
            if (x <= 0) {
                velocidadX = Math.abs(velocidadX);
            }
            if (y <= 0) {
                velocidadY = Math.abs(velocidadY);
            }
            if (x + anchoSprite >= width) {
                velocidadX = Math.abs(velocidadX) * -1;
            }
            if (y + largoSprite >= height) {
                velocidadY = Math.abs(velocidadY) * -1;
            }
            x = x + velocidadX * new Random().nextDouble();
            y = y + velocidadY * new Random().nextDouble();

        } else {
            if (chocaX()) {
                nuevarutaX();
            } else {
                if (chocaY()) {
                    nuevarutaY();
                }
            }
        }
        RutaX();
        RutaY();
    }

    private void nuevarutaX() {
        velocidadX = velocidadX * -1;
        RutaX();
        alazarY();
        RutaY();
        if (chocaY()) {
            velocidadY = velocidadY * -1;
            RutaY();
        }
    }

    private void nuevarutaY() {
        velocidadY = velocidadY * -1;
        RutaY();
        alazarX();
        RutaX();
        if (chocaX()) {
            velocidadX = velocidadX * -1;
            RutaX();
        }
    }

    private void alazarY() {
        Random random = new Random();
        if (random.nextDouble() > 0.5) {
            velocidadY = velocidadY * -1;
        }
        y = y + velocidadY * random.nextDouble();
    }

    private void alazarX() {
        Random random = new Random();
        if (random.nextDouble() > 0.5) {
            velocidadX = velocidadX * -1;
        }
        x = x + velocidadX * random.nextDouble();
    }

    /**
     * @param x the x to set
     */
    public void setX(double x) {
        this.x = x;
    }

    /**
     * @param y the y to set
     */
    public void setY(double y) {
        this.y = y;
    }

    /**
     * @param anchoSprite the anchoSprite to set
     */
    public void setAnchoSprite(double anchoSprite) {
        this.anchoSprite = anchoSprite;
    }

    /**
     * @param largoSprite the largoSprite to set
     */
    public void setLargoSprite(double largoSprite) {
        this.largoSprite = largoSprite;
    }

    /**
     * @return the x
     */
    public double getX() {
        return x;
    }

    /**
     * @return the y
     */
    public double getY() {
        return y;
    }

    public void cambioDireccionXchoque(double xO, double yO, double anchoO, double largoO) {

        if (y - velocidadY > yO & y + velocidadY < yO + largoO) {
            alazarY();
            velocidadX = velocidadX * -1;
        } else {
            if (x - velocidadX > yO & x + velocidadX < xO + anchoO) {
                alazarX();
                velocidadY = velocidadY * -1;

            } else {
                velocidadY = velocidadY * -1;
                y = y + velocidadY * new Random().nextDouble();
                velocidadX = velocidadX * -1;
                x = x + velocidadX * new Random().nextDouble();

            }
        }
    }
}
