/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


import pulpcore.Stage;
import pulpcore.scene.Scene2D;
import pulpcore.sprite.FilledSprite;
import pulpcore.sprite.ImageSprite;
import pulpcore.sprite.Label;
import static pulpcore.image.Colors.WHITE;

/**
 *
 * @author Julio Cesar Cachay Perez
 */
public class pelotapared extends Scene2D {

    private ImageSprite pelota;
    private double velocidad = 5;
    private nuevaruta NRPelota;
    Label infoText;
    Label tema;
    Label velo;

    @Override
    public void load() {
        add(new FilledSprite(WHITE));// primero agregamos el background
        NRPelota = new nuevaruta(Stage.getWidth(), Stage.getHeight(), velocidad);
        pelota = new ImageSprite("res/pelota.png", 140, 240);//cargamos la pelota
        NRPelota.setAnchoSprite(pelota.width.get());
        NRPelota.setLargoSprite(pelota.height.get());
        NRPelota.almedio();

        pelota.x.set(NRPelota.getX());//lo ponemos al centro
        pelota.y.set(NRPelota.getY());

        add(pelota);//ahora la pelota
        tema = new Label(String.valueOf(Stage.getWidth()) + " , " + String.valueOf(Stage.getHeight()), 320, 20);
        velo = new Label("", 20, 320);
        infoText = new Label("", Stage.getWidth() / 4, Stage.getHeight() / 2);
        add(velo);
        add(tema);
        add(infoText);
    }

    @Override
    public void update(int elapsedTime) {
        mover();
    }

    private void mover() {
        NRPelota.nuevaruta();
        pelota.x.set(NRPelota.getX());
        pelota.y.set(NRPelota.getY());
        String ex = String.valueOf(pelota.x.get());
        String ey = String.valueOf(pelota.y.get());
        infoText.setText(ex + " , " + ey);
        velo.setText(String.valueOf(NRPelota.velocidadX)+" , "+ String.valueOf(NRPelota.velocidadY));
    }
}
